<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li>UsersService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/services/users/services/users.service.ts</code>
        </p>




            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#eventHandle">eventHandle</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#logger">logger</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#nameCheck">nameCheck</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#addSocialAccountToUser">addSocialAccountToUser</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#checkIdAvailability">checkIdAvailability</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#checkIfNamesAreAvailable">checkIfNamesAreAvailable</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#checkIfNamesAreValid">checkIfNamesAreValid</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#checkNameAvailability">checkNameAvailability</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#createUserFromFirebase">createUserFromFirebase</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#findByUserName">findByUserName</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#findMongoUserById">findMongoUserById</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#findMongoUsersByIds">findMongoUsersByIds</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#findOne">findOne</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#findOneAdminByDocument">findOneAdminByDocument</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#findOneByDocument">findOneByDocument</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#findOneByDocumentAndBusiness">findOneByDocumentAndBusiness</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#getMongoUserByProp">getMongoUserByProp</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#getPassword">getPassword</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#updateFireUserByValuePair">updateFireUserByValuePair</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#updateMongoUserByValuePair">updateMongoUserByValuePair</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#updateNotificationCredentials">updateNotificationCredentials</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#updateUserElementInArray">updateUserElementInArray</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(commandBus: CommandBus, publisher: EventPublisher)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="57" class="link-to-prism">src/services/users/services/users.service.ts:57</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>commandBus</td>
                                                  
                                                        <td>
                                                                    <code>CommandBus</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>publisher</td>
                                                  
                                                        <td>
                                                                    <code>EventPublisher</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="addSocialAccountToUser"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            addSocialAccountToUser
                        </b>
                        <a href="#addSocialAccountToUser"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>addSocialAccountToUser(user_id: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, access_token: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="134"
                            class="link-to-prism">src/services/users/services/users.service.ts:134</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_id</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>access_token</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="checkIdAvailability"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            checkIdAvailability
                        </b>
                        <a href="#checkIdAvailability"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>checkIdAvailability(id: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="202"
                            class="link-to-prism">src/services/users/services/users.service.ts:202</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>id</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="checkIfNamesAreAvailable"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            checkIfNamesAreAvailable
                        </b>
                        <a href="#checkIfNamesAreAvailable"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>checkIfNamesAreAvailable(username: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="241"
                            class="link-to-prism">src/services/users/services/users.service.ts:241</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>username</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="checkIfNamesAreValid"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            checkIfNamesAreValid
                        </b>
                        <a href="#checkIfNamesAreValid"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>checkIfNamesAreValid(username: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="230"
                            class="link-to-prism">src/services/users/services/users.service.ts:230</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>username</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>INameCheck&lt;boolean&gt;</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="checkNameAvailability"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            checkNameAvailability
                        </b>
                        <a href="#checkNameAvailability"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>checkNameAvailability(name: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, prop)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="207"
                            class="link-to-prism">src/services/users/services/users.service.ts:207</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Default value</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>name</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                    </td>

                                </tr>
                                <tr>
                                    <td>prop</td>
                                    <td>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>&#x27;username&#x27;</code>
                                    </td>

                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="createUserFromFirebase"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            createUserFromFirebase
                        </b>
                        <a href="#createUserFromFirebase"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>createUserFromFirebase(payload: <a href="../interfaces/ICreateFireUserParams.html">ICreateFireUserParams</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="71"
                            class="link-to-prism">src/services/users/services/users.service.ts:71</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>payload</td>
                                    <td>
                                                <code><a href="../interfaces/ICreateFireUserParams.html" target="_self" >ICreateFireUserParams</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="findByUserName"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            findByUserName
                        </b>
                        <a href="#findByUserName"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>findByUserName(username: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="192"
                            class="link-to-prism">src/services/users/services/users.service.ts:192</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>username</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/IUserFireEntity.html" target="_self" >Promise&lt;IUserFireEntity | undefined&gt;</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="findMongoUserById"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            findMongoUserById
                        </b>
                        <a href="#findMongoUserById"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>findMongoUserById(user_id: ObjectId)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="139"
                            class="link-to-prism">src/services/users/services/users.service.ts:139</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_id</td>
                                    <td>
                                            <code>ObjectId</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="findMongoUsersByIds"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            findMongoUsersByIds
                        </b>
                        <a href="#findMongoUsersByIds"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>findMongoUsersByIds(user_ids: ObjectId[])</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="144"
                            class="link-to-prism">src/services/users/services/users.service.ts:144</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_ids</td>
                                    <td>
                                            <code>ObjectId[]</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="findOne"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            findOne
                        </b>
                        <a href="#findOne"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>findOne(prop, input: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="149"
                            class="link-to-prism">src/services/users/services/users.service.ts:149</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>prop</td>
                                    <td>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>input</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/IUserFireEntity.html" target="_self" >Promise&lt;IUserFireEntity | null&gt;</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="findOneAdminByDocument"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            findOneAdminByDocument
                        </b>
                        <a href="#findOneAdminByDocument"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>findOneAdminByDocument(input: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="169"
                            class="link-to-prism">src/services/users/services/users.service.ts:169</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>input</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/IUserFireEntity.html" target="_self" >Promise&lt;IUserFireEntity | null&gt;</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="findOneByDocument"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            findOneByDocument
                        </b>
                        <a href="#findOneByDocument"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>findOneByDocument(input: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="159"
                            class="link-to-prism">src/services/users/services/users.service.ts:159</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>input</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/IUserFireEntity.html" target="_self" >Promise&lt;IUserFireEntity | null&gt;</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="findOneByDocumentAndBusiness"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            findOneByDocumentAndBusiness
                        </b>
                        <a href="#findOneByDocumentAndBusiness"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>findOneByDocumentAndBusiness(input: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="180"
                            class="link-to-prism">src/services/users/services/users.service.ts:180</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>input</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/IUserFireEntity.html" target="_self" >Promise&lt;IUserFireEntity | null&gt;</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getMongoUserByProp"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            getMongoUserByProp
                        </b>
                        <a href="#getMongoUserByProp"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getMongoUserByProp(prop: K, value)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="269"
                            class="link-to-prism">src/services/users/services/users.service.ts:269</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>T</li>
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>prop</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>value</td>
                                    <td>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getPassword"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            getPassword
                        </b>
                        <a href="#getPassword"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getPassword(user_id: ObjectId)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="259"
                            class="link-to-prism">src/services/users/services/users.service.ts:259</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_id</td>
                                    <td>
                                            <code>ObjectId</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateFireUserByValuePair"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            updateFireUserByValuePair
                        </b>
                        <a href="#updateFireUserByValuePair"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateFireUserByValuePair(user_id: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, prop: K, value)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="388"
                            class="link-to-prism">src/services/users/services/users.service.ts:388</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>T</li>
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_id</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>prop</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>value</td>
                                    <td>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateMongoUserByValuePair"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            updateMongoUserByValuePair
                        </b>
                        <a href="#updateMongoUserByValuePair"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateMongoUserByValuePair(user_id: ObjectId, prop: K, value)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="285"
                            class="link-to-prism">src/services/users/services/users.service.ts:285</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>T</li>
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_id</td>
                                    <td>
                                            <code>ObjectId</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>prop</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>value</td>
                                    <td>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateNotificationCredentials"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            updateNotificationCredentials
                        </b>
                        <a href="#updateNotificationCredentials"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateNotificationCredentials(user_id: ObjectId, entity: <a href="../interfaces/INotificationCredential.html">INotificationCredential</a>, array_filters: <a href="../interfaces/INotificationCredential.html">Partial<INotificationCredential></a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="317"
                            class="link-to-prism">src/services/users/services/users.service.ts:317</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_id</td>
                                    <td>
                                            <code>ObjectId</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>entity</td>
                                    <td>
                                                <code><a href="../interfaces/INotificationCredential.html" target="_self" >INotificationCredential</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>array_filters</td>
                                    <td>
                                                <code><a href="../interfaces/INotificationCredential.html" target="_self" >Partial&lt;INotificationCredential&gt;</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateUserElementInArray"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            updateUserElementInArray
                        </b>
                        <a href="#updateUserElementInArray"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateUserElementInArray(user_id: ObjectId, pairs: literal type[], array_filters: literal type[])</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="344"
                            class="link-to-prism">src/services/users/services/users.service.ts:344</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>P</li>
                        <li>U</li>
                        <li>V</li>
                        <li>U2</li>
                        <li>V2</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>user_id</td>
                                    <td>
                                            <code>ObjectId</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>pairs</td>
                                    <td>
                                            <code>literal type[]</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>array_filters</td>
                                    <td>
                                            <code>literal type[]</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="eventHandle"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            eventHandle</b>
                            <a href="#eventHandle"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>        <code><a href="../classes/UserEventHandle.html" target="_self" >UserEventHandle</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="57" class="link-to-prism">src/services/users/services/users.service.ts:57</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(UsersService.name)</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="56" class="link-to-prism">src/services/users/services/users.service.ts:56</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="nameCheck"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            nameCheck</b>
                            <a href="#nameCheck"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>() &#x3D;&gt; {...}</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="219" class="link-to-prism">src/services/users/services/users.service.ts:219</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable, Logger } from &#x27;@nestjs/common&#x27;
import { ObjectId } from &#x27;mongodb&#x27;
import { CommandBus, EventPublisher } from &#x27;@nestjs/cqrs&#x27;
import {
    getUserByUsername, checkIfUsernameExists, getUserByProp, getPasswordById, addSocialAccountToUser, getUserByDocument, updateFireUserByValuePairs
} from &#x27;./../repositories/user-firebase.repository&#x27;
// import { toDataURL } from &#x27;qrcode&#x27;
// import * as QRCode from &#x27;qrcode&#x27;
// import * as jimp from &#x27;jimp&#x27;
import { UserEventHandle } from &#x27;../events/users.aggregate&#x27;
import { createHmac } from &#x27;crypto&#x27;
import { updateUserElementInArray, updateMongoUserByValuePairs, getMongoUserByProp, getMongoUsersByIds } from &#x27;../repositories/user.repository&#x27;
import { objectToValuePairs } from &#x27;src/common/utility/pipe-utility&#x27;
import { IMongoEntity, IFirestoreEntity, IMongoStringEntity } from &#x27;src/models/common/common&#x27;
import { IUserFireEntity, IUserMongoEntity, INotificationCredential, IUserEntityBaseArrayMap } from &#x27;../models&#x27;
import { ISocialAccount, SocialProviders } from &#x27;../models/social-account&#x27;
// import { checkIfNameExists } from &#x27;../players/players.repository&#x27;
// import { CurrencyService } from &#x27;../currency/currency.service&#x27;

// http://thecodebarbarian.com/creating-qr-codes-with-node-js.html

interface ICreateUserParams {
    username: string
    password: string
    // player_name: string
    // family_name: string
}

interface ICreateUserParamsBase {
    username: string
    password: string
    email: string
    access_token: string
    first_name: string
    last_name: string
    avatar: string
    avatar_url: string
    private_account: boolean
    use_real_name: boolean
}

interface ICreateMongoUserParams extends ICreateUserParamsBase, IMongoEntity, IFirestoreEntity {
}

interface ICreateFireUserParams extends ICreateUserParamsBase, IFirestoreEntity, IMongoStringEntity {
}

interface INameCheck&lt;T extends string | boolean&gt; {
    username: T
    // player_name: T
    // family_name: T
}

@Injectable()
export class UsersService {
    private readonly logger &#x3D; new Logger(UsersService.name)
    private readonly eventHandle: UserEventHandle

    constructor(
        private readonly commandBus: CommandBus,
        // private readonly eventBus: EventBus,
        private readonly publisher: EventPublisher,
        // private readonly currencyService: CurrencyService,
    ) {
        this.eventHandle &#x3D;
            publisher.mergeObjectContext(
                new UserEventHandle(new ObjectId().toHexString()))
        this.eventHandle.autoCommit &#x3D; true
    }

    async createUserFromFirebase(payload: ICreateFireUserParams) {
        const body_values &#x3D; Object.values(payload)

        if (body_values.some((s) &#x3D;&gt; s &#x3D;&#x3D;&#x3D; undefined)) {
            return {
                id: &#x27;&#x27;,
                access_token: &#x27;&#x27;,
                validation_passed: false,
            }
        }
        const {
            _id,
            fire_id,
            username,
            password,
            email,
            access_token,
            first_name,
            last_name,
            avatar,
            avatar_url,
            private_account,
            use_real_name,
        } &#x3D; payload

        const hash &#x3D;
            createHmac(&#x27;sha512&#x27;, process.env.ACCOUNT_KEY)
                .update(access_token)
                .digest(&#x27;hex&#x27;)

        let account: ISocialAccount &#x3D; {
            id: &#x27;&#x27;,
            access_token: hash,
            email: &#x27;&#x27;,
            provider: SocialProviders.FACEBOOK,
            username: &#x27;&#x27;,
        }

        let user_id &#x3D;
            await this.eventHandle
                .createUser(
                    fire_id,
                    _id,
                    username,
                    password,
                    email,
                    account,
                    first_name,
                    last_name,
                    avatar,
                    avatar_url,
                    private_account,
                    use_real_name)

        // let res &#x3D; await addSocialAccountToUser(id, access_token)

        return {
            id: user_id,
            access_token: access_token,
            validation_passed: true,
        }
    }

    async addSocialAccountToUser(user_id: string, access_token: string) {
        return await this.eventHandle
            .addSocialAccountToUser(user_id, access_token)
    }

    async findMongoUserById(user_id: ObjectId) {
        let res &#x3D; await getMongoUserByProp(&#x27;_id&#x27;, user_id)
        return res
    }

    async findMongoUsersByIds(user_ids: ObjectId[]) {
        let res &#x3D; await getMongoUsersByIds(user_ids)
        return res
    }

    async findOne(prop: keyof IUserFireEntity, input: string): Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByProp(prop, input)

        if (user !&#x3D;&#x3D; null) {
            return user
        } else {
            return null
        }
    }

    async findOneByDocument(input: string): Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByDocument(input)

        if (user !&#x3D;&#x3D; null) {
            return user
        } else {
            return null
        }
    }

    async findOneAdminByDocument(input: string): Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByDocument(input)

        if (user !&#x3D;&#x3D; null &amp;&amp;
            user.is_admin) {
            return user
        } else {
            return null
        }
    }

    async findOneByDocumentAndBusiness(input: string):
        Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByDocument(input)

        if (user !&#x3D;&#x3D; null &amp;&amp;
            user.is_admin) {
            return user
        } else {
            return null
        }
    }

    async findByUserName(username: string): Promise&lt;IUserFireEntity | undefined&gt; {
        const user &#x3D; await getUserByUsername(username)

        if (user !&#x3D;&#x3D; null) {
            return user
        } else {
            return null
        }
    }

    async checkIdAvailability(
        id: string
    ) {
    }

    async checkNameAvailability(
        name: string,
        // prop: &#x27;username&#x27; | &#x27;player_name&#x27; | &#x27;family_name&#x27; &#x3D; &#x27;username&#x27;
        prop: &#x27;username&#x27; &#x3D; &#x27;username&#x27;
    ) {
        if (prop &#x3D;&#x3D;&#x3D; &#x27;username&#x27;) {
            return await checkIfUsernameExists(name)
        } else {
            // return await checkIfNameExists(name, prop)
        }
    }

    private nameCheck &#x3D; (input: string, minLength: number &#x3D; 3, maxLength: number &#x3D; 15) &#x3D;&gt; {
        const spaceCheck &#x3D; new RegExp(/\s/)
        if (input.length &gt;&#x3D; 3 &amp;&amp;
            input.length &lt;&#x3D; 15 &amp;&amp;
            !spaceCheck.test(input)) {
            return true
        } else {
            return false
        }
    }

    private checkIfNamesAreValid(username: string) {

        const u &#x3D; this.nameCheck(username)

        const res: INameCheck&lt;boolean&gt; &#x3D; {
            username: u,
        }

        return res
    }

    async checkIfNamesAreAvailable(username: string) {
        const nres &#x3D; this.checkIfNamesAreValid(username)
        const entries: boolean[] &#x3D; Object.values(nres)

        if (entries.some(s &#x3D;&gt; s &#x3D;&#x3D;&#x3D; false)) {
            return nres
        }

        const usernameExists &#x3D;
            await this.checkNameAvailability(username, &#x27;username&#x27;)

        const res: INameCheck&lt;boolean&gt; &#x3D; {
            username: !usernameExists,
        }

        return res
    }

    async getPassword(user_id: ObjectId) {
        const pw &#x3D; await getPasswordById(user_id)

        if (pw !&#x3D;&#x3D; null) {
            return pw
        } else {
            return null
        }
    }

    async getMongoUserByProp&lt;
        T extends IUserMongoEntity,
        K extends keyof T
    &gt;(
        prop: K,
        value: T[K],
    ) {
        try {
            let res &#x3D; await getMongoUserByProp(prop, value)
            return res
        } catch (error) {
            this.logger.error(error)
            return null
        }
    }

    async updateMongoUserByValuePair&lt;
        T extends IUserMongoEntity,
        K extends keyof IUserMongoEntity,
        &gt;(
            user_id: ObjectId,
            prop: K,
            value: T[K],
    ) {
        let res &#x3D; await updateMongoUserByValuePairs(user_id, [{
            prop,
            value,
        }])
        return res
    }

    // async updateNotificationCredentials&lt;
    //     T extends Partial&lt;INotificationCredential&gt;,
    //     K extends keyof Partial&lt;INotificationCredential&gt;
    // &gt;(
    //     user_id: ObjectId,
    //     pairs: {
    //         prop: K,
    //         value: T[K],
    //     }[],
    //     array_filters: {
    //         prop: K,
    //         value: T[K],
    //     }[],
    // ) {

    // }

    async updateNotificationCredentials(
        user_id: ObjectId,
        entity: INotificationCredential,
        array_filters: Partial&lt;INotificationCredential&gt;,
    ) {
        let res &#x3D;
            await updateUserElementInArray(
                user_id,
                &#x27;notification_credentials&#x27;,
                entity,
                array_filters)

        this.logger.debug(this.updateNotificationCredentials.name)
        console.log(res)

        return res
        // let pairs &#x3D; objectToValuePairs(entity)
        // let filters &#x3D; objectToValuePairs(array_filters)
        // let res &#x3D;
        //     await updateElementInArray(user_id, [
        //         {
        //             array_prop: &#x27;notification_credentials&#x27;,
        //             prop: 
        //         }
        //     ])
    }

    async updateUserElementInArray&lt;
        // K extends keyof Pick&lt;IUserEntityBase, &#x27;notification_credentials&#x27; | &#x27;roles&#x27; | &#x27;role_access&#x27; | &#x27;social_accounts&#x27;&gt;,
        // T extends IUserEntityBaseArrayMap,
        // P extends keyof T,
        // V extends T[P],
        // U extends keyof T[P],
        P extends keyof IUserEntityBaseArrayMap,
        U extends keyof IUserEntityBaseArrayMap[P],
        V extends IUserEntityBaseArrayMap[P],
        U2 extends keyof IUserEntityBaseArrayMap[P],
        V2 extends IUserEntityBaseArrayMap[P],
        &gt;(
            user_id: ObjectId,
            pairs: {
                // array_prop: K,
                array_prop: P,
                prop: U,
                value: V[U]
            }[],
            array_filters: {
                prop: U2,
                value: V2[U2]
            }[],
        // array_filters: {
        //     prop: P,
        //     value: U[P]
        // }[],
    ) {
        // // let res &#x3D; await updateMongoUserByValuePairs(user_id, [{
        // //     prop,
        // //     value,
        // // }])
        // // return res

        // let res &#x3D;
        //     await updateElementInArray(user_id, pairs, [
        //         {
        //             prop: &#x27;device_id&#x27;,
        //             value: &#x27;&#x27;,
        //         }
        //     ])
        // return res
    }

    async updateFireUserByValuePair&lt;
        T extends IUserFireEntity,
        K extends keyof IUserFireEntity,
        &gt;(
            user_id: string,
            prop: K,
            value: T[K],
    ) {
        let res &#x3D; await updateFireUserByValuePairs(user_id, [{
            prop,
            value,
        }])
        return res
    }
}</code></pre>
    </div>

</div>







                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'UsersService.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
